#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <./usb.h>

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(char *name, int arg)
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	break;
    case 'T':
	break;
    case 'U':
	if (strEQ(name, "USB_CLASS_AUDIO"))
#ifdef USB_CLASS_AUDIO
	    return USB_CLASS_AUDIO;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_COMM"))
#ifdef USB_CLASS_COMM
	    return USB_CLASS_COMM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_DATA"))
#ifdef USB_CLASS_DATA
	    return USB_CLASS_DATA;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_HID"))
#ifdef USB_CLASS_HID
	    return USB_CLASS_HID;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_HUB"))
#ifdef USB_CLASS_HUB
	    return USB_CLASS_HUB;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_MASS_STORAGE"))
#ifdef USB_CLASS_MASS_STORAGE
	    return USB_CLASS_MASS_STORAGE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_PER_INTERFACE"))
#ifdef USB_CLASS_PER_INTERFACE
	    return USB_CLASS_PER_INTERFACE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_PRINTER"))
#ifdef USB_CLASS_PRINTER
	    return USB_CLASS_PRINTER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_CLASS_VENDOR_SPEC"))
#ifdef USB_CLASS_VENDOR_SPEC
	    return USB_CLASS_VENDOR_SPEC;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_CONFIG"))
#ifdef USB_DT_CONFIG
	    return USB_DT_CONFIG;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_CONFIG_SIZE"))
#ifdef USB_DT_CONFIG_SIZE
	    return USB_DT_CONFIG_SIZE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_DEVICE"))
#ifdef USB_DT_DEVICE
	    return USB_DT_DEVICE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_DEVICE_SIZE"))
#ifdef USB_DT_DEVICE_SIZE
	    return USB_DT_DEVICE_SIZE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_ENDPOINT"))
#ifdef USB_DT_ENDPOINT
	    return USB_DT_ENDPOINT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_ENDPOINT_AUDIO_SIZE"))
#ifdef USB_DT_ENDPOINT_AUDIO_SIZE
	    return USB_DT_ENDPOINT_AUDIO_SIZE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_ENDPOINT_SIZE"))
#ifdef USB_DT_ENDPOINT_SIZE
	    return USB_DT_ENDPOINT_SIZE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_HID"))
#ifdef USB_DT_HID
	    return USB_DT_HID;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_HUB"))
#ifdef USB_DT_HUB
	    return USB_DT_HUB;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_HUB_NONVAR_SIZE"))
#ifdef USB_DT_HUB_NONVAR_SIZE
	    return USB_DT_HUB_NONVAR_SIZE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_INTERFACE"))
#ifdef USB_DT_INTERFACE
	    return USB_DT_INTERFACE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_INTERFACE_SIZE"))
#ifdef USB_DT_INTERFACE_SIZE
	    return USB_DT_INTERFACE_SIZE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_PHYSICAL"))
#ifdef USB_DT_PHYSICAL
	    return USB_DT_PHYSICAL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_REPORT"))
#ifdef USB_DT_REPORT
	    return USB_DT_REPORT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_DT_STRING"))
#ifdef USB_DT_STRING
	    return USB_DT_STRING;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_ERROR_BEGIN"))
#ifdef USB_ERROR_BEGIN
	    return USB_ERROR_BEGIN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_RECIP_DEVICE"))
#ifdef USB_RECIP_DEVICE
	    return USB_RECIP_DEVICE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_RECIP_ENDPOINT"))
#ifdef USB_RECIP_ENDPOINT
	    return USB_RECIP_ENDPOINT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_RECIP_INTERFACE"))
#ifdef USB_RECIP_INTERFACE
	    return USB_RECIP_INTERFACE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_RECIP_OTHER"))
#ifdef USB_RECIP_OTHER
	    return USB_RECIP_OTHER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_CLEAR_FEATURE"))
#ifdef USB_REQ_CLEAR_FEATURE
	    return USB_REQ_CLEAR_FEATURE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_GET_CONFIGURATION"))
#ifdef USB_REQ_GET_CONFIGURATION
	    return USB_REQ_GET_CONFIGURATION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_GET_DESCRIPTOR"))
#ifdef USB_REQ_GET_DESCRIPTOR
	    return USB_REQ_GET_DESCRIPTOR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_GET_INTERFACE"))
#ifdef USB_REQ_GET_INTERFACE
	    return USB_REQ_GET_INTERFACE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_GET_STATUS"))
#ifdef USB_REQ_GET_STATUS
	    return USB_REQ_GET_STATUS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_SET_ADDRESS"))
#ifdef USB_REQ_SET_ADDRESS
	    return USB_REQ_SET_ADDRESS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_SET_CONFIGURATION"))
#ifdef USB_REQ_SET_CONFIGURATION
	    return USB_REQ_SET_CONFIGURATION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_SET_DESCRIPTOR"))
#ifdef USB_REQ_SET_DESCRIPTOR
	    return USB_REQ_SET_DESCRIPTOR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_SET_FEATURE"))
#ifdef USB_REQ_SET_FEATURE
	    return USB_REQ_SET_FEATURE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_SET_INTERFACE"))
#ifdef USB_REQ_SET_INTERFACE
	    return USB_REQ_SET_INTERFACE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_REQ_SYNCH_FRAME"))
#ifdef USB_REQ_SYNCH_FRAME
	    return USB_REQ_SYNCH_FRAME;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_TYPE_CLASS"))
#ifdef USB_TYPE_CLASS
	    return USB_TYPE_CLASS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_TYPE_RESERVED"))
#ifdef USB_TYPE_RESERVED
	    return USB_TYPE_RESERVED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_TYPE_STANDARD"))
#ifdef USB_TYPE_STANDARD
	    return USB_TYPE_STANDARD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USB_TYPE_VENDOR"))
#ifdef USB_TYPE_VENDOR
	    return USB_TYPE_VENDOR;
#else
	    goto not_there;
#endif
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


MODULE = USB		PACKAGE = USB		


double
constant(name,arg)
	char *		name
	int		arg


usb_dev_handle *
usb_open(dev)
	struct usb_device *	dev

int
usb_close(dev)
	usb_dev_handle *	dev

int
usb_bulk_write(dev, ep, bytes, size, timeout)
	usb_dev_handle *	dev
	int	ep
	char *	bytes
	int	size
	int	timeout

int
usb_bulk_read(dev, ep, bytes, size, timeout)
	usb_dev_handle *	dev
	int	ep
	char *	bytes
	int	size
	int	timeout

int
usb_control_msg(dev, requesttype, request, value, index, bytes, size, timeout)
	usb_dev_handle *	dev
	int	requesttype
	int	request
	int	value
	int	index
	char *	bytes
	int	size
	int	timeout

int
usb_set_configuration(dev, configuration)
	usb_dev_handle *	dev
	int	configuration

int
usb_claim_interface(dev, interface)
	usb_dev_handle *	dev
	int	interface

int
usb_release_interface(dev, interface)
	usb_dev_handle *	dev
	int	interface

int
usb_set_altinterface(dev, alternate)
	usb_dev_handle *	dev
	int	alternate

int
usb_resetep(dev, ep)
	usb_dev_handle *	dev
	unsigned int	ep

int
usb_clear_halt(dev, ep)
	usb_dev_handle *	dev
	unsigned int	ep

int
usb_reset(dev)
	usb_dev_handle *	dev

char *
usb_strerror()

void
usb_init()

void
usb_set_debug(level)
	int	level

int
usb_find_busses()

int
usb_find_devices()

struct usb_device *
usb_device(dev)
	usb_dev_handle *	dev

struct usb_bus *
get_usb_busses()
	CODE:
	RETVAL = usb_busses;
	OUTPUT:
	RETVAL 

struct usb_bus *
get_usb_next_bus(bus)
	struct usb_bus *bus
	CODE:
	RETVAL = bus->next;
	OUTPUT:
	RETVAL

struct usb_bus *
get_usb_prev_bus(bus)
	struct usb_bus *bus
	CODE:
	RETVAL = bus->prev;
	OUTPUT:
	RETVAL

char *
get_usb_busname(bus)
	struct usb_bus *bus
	CODE:
	RETVAL = bus->dirname;
	OUTPUT:
	RETVAL

struct usb_device *
get_usb_devices(bus)
	struct usb_bus *bus
	CODE:
	RETVAL = bus->devices;
	OUTPUT:
	RETVAL

struct usb_device *
get_usb_next_device(device)
	struct usb_device *device
	CODE:
	RETVAL = device->next;
	OUTPUT:
	RETVAL

struct usb_device *
get_usb_prev_device(device)
	struct usb_device *device
	CODE:
	RETVAL = device->prev;
	OUTPUT:
	RETVAL

char *
get_usb_devicename(device)
	struct usb_device *device
	CODE:
	RETVAL = device->filename;
	OUTPUT:
	RETVAL

HV *
get_usb_device_descriptor(device)
	struct usb_device *device
	PREINIT:
	void addnumtoHV(HV *tmpHV, char *str, double dat)
	{
		SV *tmpSV;
	
		tmpSV = newSVnv(dat);
		hv_store(tmpHV, str, strlen(str), tmpSV, 0);
	}

	HV *tmpHV;
	CODE:

	tmpHV = newHV();

	addnumtoHV(tmpHV, "bLength", device->descriptor.bLength);
	addnumtoHV(tmpHV, "bDescriptorType", device->descriptor.bDescriptorType);
	addnumtoHV(tmpHV, "bcdUSB", device->descriptor.bcdUSB);
	addnumtoHV(tmpHV, "bDeviceClass", device->descriptor.bDeviceClass);
	addnumtoHV(tmpHV, "bDeviceSubClass", device->descriptor.bDeviceSubClass);
	addnumtoHV(tmpHV, "bDeviceProtocol", device->descriptor.bDeviceProtocol);
	addnumtoHV(tmpHV, "bMaxPacketSize0", device->descriptor.bMaxPacketSize0);
	addnumtoHV(tmpHV, "idVendor", device->descriptor.idVendor);
	addnumtoHV(tmpHV, "idProduct", device->descriptor.idProduct);

	addnumtoHV(tmpHV, "bcdDevice", device->descriptor.bcdDevice);
	addnumtoHV(tmpHV, "iManufacturer", device->descriptor.iManufacturer);
	addnumtoHV(tmpHV, "iProduct", device->descriptor.iProduct);
	addnumtoHV(tmpHV, "iSerialNumber", device->descriptor.iSerialNumber);
	addnumtoHV(tmpHV, "bNumConfigurations", device->descriptor.bNumConfigurations);


	RETVAL = tmpHV;
	OUTPUT:
	RETVAL

