# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..1\n"; }
END {print "not ok 1\n" unless $loaded;}
use USB;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

print &USB::usb_init() == NULL ? "ok 2" : "not ok 2", "\n";
print &USB::usb_find_busses() == 0 ? "ok 3" : "not ok 3", "\n";
print &USB::usb_find_devices() == 0 ? "ok 4" : "not ok 4", "\n";

my($blah) = &USB::get_usb_busses();

do
{
	printf("Scanning bus name = %s\n",  &USB::get_usb_busname($blah));
	my($blah2) = &USB::get_usb_devices($blah);
	do
	{
		printf("Scanning device name = %s\n",  &USB::get_usb_devicename($blah2));
		%tt = %{ USB::get_usb_device_descriptor($blah2) };

		foreach (keys(%tt))
		{
			printf("key = '%s' data='0x%04X'\n", $_, $tt{$_});
		}
                if($tt{bDeviceClass} eq "9")
                {
                  my $udev=&USB::usb_open($blah2);                  

                  print "HUB DETECTED: $blah2  $udev!\n";
                  foreach $port (0 .. 4)
                  {
                    print "Switching off ...\n";
                    &USB::usb_control_msg($udev, $USB_REQ_CLEAR_FEATURE, USB_RT_PORT,USB_PORT_FEAT_POWER, $port, NULL, 0, 1000);
                    sleep(1);
                    print "Switching on ...\n";  
                    &USB::usb_control_msg($udev, $USB_REQ_SET_FEATURE, USB_RT_PORT,USB_PORT_FEAT_POWER, $port, NULL, 0, 1000);
                  }
                  usb_close($udev);
                }

		printf("idVendor=0x%04X idProduct =0x%04X\n", $tt{"idVendor"}, $tt{"idProduct"});

		$hdl = &USB::usb_open($blah2);
		&USB::usb_close($hdl);
	} while ($blah2 = &USB::get_usb_next_device($blah2));
} while ($blah = &USB::get_usb_next_bus($blah))


